unit hiImg_FocusRect;

interface

uses Windows,Kol,Share,Img_Draw;

{$I share.inc}

type
  THIImg_FocusRect = class(THIDraw2PR)
   private
    rect, oldrect: TRect;
   public
   _event_onClear: THI_Event;
   
   procedure _work_doDraw(var _Data:TData; Index:word);
   procedure _work_doClear(var _Data:TData; Index:word);
   procedure _var_RectLeft(var _Data:TData; Index:word);
   procedure _var_RectTop(var _Data:TData; Index:word);
   procedure _var_RectRight(var _Data:TData; Index:word);
   procedure _var_RectBottom(var _Data:TData; Index:word);
   procedure _var_RectPoint1(var _Data:TData; Index:word);
   procedure _var_RectPoint2(var _Data:TData; Index:word);
  end;

implementation

procedure THIImg_FocusRect._work_doDraw;
var dt: TData;
begin
    dt := _Data;
TRY
    if not ImgGetDC(_Data) then exit;
    ReadXY(_Data);
    ImgNewSizeDC;
    DrawFocusRect(pDC, rect);
    SetRect(rect, min(x1,x2), min(y1,y2), max(x1,x2), max(y1,y2));
    DrawFocusRect(pDC, rect);
FINALLY
   ImgReleaseDC;
   _hi_CreateEvent(_Data,@_event_onDraw, dt);
END;
end;


procedure THIImg_FocusRect._work_doClear;
var dt: TData;
begin
    dt := _Data;
TRY
    if not ImgGetDC(_Data) then exit;
    DrawFocusRect(pDC, rect);
    oldrect := rect;
    SetRectEmpty(rect);
FINALLY
   ImgReleaseDC;
   _hi_CreateEvent(_Data,@_event_onClear, dt);
END;
end;

procedure THIImg_FocusRect._var_RectLeft;
begin
   dtInteger(_Data, oldrect.Left);
end;

procedure THIImg_FocusRect._var_RectTop;
begin
   dtInteger(_Data, oldrect.Top);
end;

procedure THIImg_FocusRect._var_RectRight;
begin
   dtInteger(_Data, oldrect.Right);
end;

procedure THIImg_FocusRect._var_RectBottom;
begin
   dtInteger(_Data, oldrect.Bottom);
end;

procedure THIImg_FocusRect._var_RectPoint1;
begin
   dtInteger(_Data, oldrect.Top shl 16 + oldrect.Left);
end;

procedure THIImg_FocusRect._var_RectPoint2;
begin
   dtInteger(_Data, oldrect.Bottom shl 16 + oldrect.Right);
end;

end.